<script setup lang="ts">
import { ref, onMounted } from "vue";
import { useQuasar } from "quasar";

import http from "@/plugins/http";
import config from "@/app.config";
import { useCounterMixin } from "@/stores/mixin";
import { usePersonalDataStore } from "@/modules/01_metadata/stores/personalStore";

import type { QTableProps } from "quasar";

import DialogForm from "@/modules/01_metadata/components/personal/DialogForm.vue"; // เพิ่มข้อมูล,แก้ไขข้อมูล

const $q = useQuasar();
const store = usePersonalDataStore();
const { messageError, showLoader, hideLoader, success, dialogRemove } =
  useCounterMixin();

/** Table*/
const columns = [
  {
    name: "gender",
    align: "left",
    label: "เพศ",
    sortable: true,
    field: "name",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "createdAt",
    align: "left",
    label: "วันที่สร้าง",
    sortable: true,
    field: "createdAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdatedAt",
    align: "left",
    label: "วันที่แก้ไข",
    sortable: true,
    field: "lastUpdatedAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdateFullName",
    align: "left",
    label: "ผู้ดำเนินการ",
    sortable: true,
    field: "lastUpdateFullName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
] as const satisfies QTableProps["columns"];
const visibleColumns = ref<string[]>([
  "gender",
  "createdAt",
  "lastUpdatedAt",
  "lastUpdateFullName",
]);
const pagination = ref({
  sortBy: "gender",
});

const filterKeyword = ref<string>(""); //คำค้นหา
const dialog = ref<boolean>(false); // เพิ่มข้อมูล,แก้ไขข้อมูล
const gender = ref<string>(""); // เพศ
const editId = ref<string>(""); // id เพศ
const dialogStatus = ref<string>(""); // สถานะ เพิ่มข้อมูล,แก้ไขข้อมูล
const personalName = ref<string>("เพศ"); //label input

/**
 * fetch ข้อมูลรายการ เพศ
 * บันทึกข้อมูลลงใน store
 */
async function fetchData() {
  showLoader();
  await http
    .get(config.API.orgGender)
    .then(async (res) => {
      await store.save(res.data.result);
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * เพิ่มข้อมูลรายการเพศ
 * แล้ว fetch ข้อมูลรายการเพศ ใหม่
 */
async function addData() {
  showLoader();
  await http
    .post(config.API.orgGender, {
      name: gender.value,
    })
    .then(async () => {
      await fetchData();
      success($q, "บันทึกข้อมูลสำเร็จ");
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * แก้ไขข้อมูลรายการเพศ
 * แล้ว fetch ข้อมูลรายการเพศ ใหม่
 * @param id รายการเพศ
 */
async function editData(id: string) {
  showLoader();
  await http
    .put(config.API.orgGenderId(id), {
      name: gender.value,
    })
    .then(async () => {
      await fetchData();
      success($q, "บันทึกข้อมูลสำเร็จ");
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * ลบรายการเพศ
 * แล้ว fetch ข้อมูลรายการ ข้อมูลรายการเพศ ใหม่
 * @param id รายการเพศ
 */
async function onDeleteData(id: string) {
  dialogRemove($q, async () => {
    showLoader();
    await http
      .delete(config.API.orgGenderId(id))
      .then(async () => {
        await fetchData();
        success($q, "ลบข้อมูลสำเร็จ");
      })
      .catch((err) => {
        messageError($q, err);
      })
      .finally(() => {
        hideLoader();
      });
  });
}

/**
 * hook ทำงานเมื่อ Components ถูกเรียกใช้งาน
 * แล้วเรียก function fetch ข้อมูลรายการเพศ
 */
onMounted(async () => {
  await fetchData();
});
</script>

<template>
  <q-toolbar style="padding: 0">
    <q-btn
      flat
      round
      color="primary"
      icon="add"
      @click.stop="
        () => {
          dialogStatus = 'create';
          dialog = true;
        }
      "
    >
      <q-tooltip> เพิ่มข้อมูล </q-tooltip>
    </q-btn>
    <q-space />
    <div class="row q-gutter-sm">
      <q-input
        dense
        outlined
        v-model="filterKeyword"
        placeholder="ค้นหา"
        @keydown.enter.prevent="store.onSearchData(filterKeyword, columns)"
      >
        <template v-slot:append>
          <q-icon name="search" />
        </template>
      </q-input>
      <q-select
        v-model="visibleColumns"
        multiple
        outlined
        dense
        options-dense
        :display-value="$q.lang.table.columns"
        emit-value
        map-options
        :options="columns"
        option-value="name"
        style="min-width: 140px"
      />
    </div>
  </q-toolbar>

  <d-table
    ref="table"
    :columns="columns"
    :rows="store.row"
    row-key="name"
    flat
    bordered
    dense
    class="custom-header-table"
    :visible-columns="visibleColumns"
    v-model:pagination="pagination"
  >
    <template v-slot:header="props">
      <q-tr :props="props">
        <q-th auto-width />
        <q-th v-for="col in props.cols" :key="col.name" :props="props">
          <span class="text-weight-medium">{{ col.label }}</span>
        </q-th>
      </q-tr>
    </template>
    <template v-slot:body="props">
      <q-tr :props="props">
        <q-td auto-width>
          <q-btn
            color="edit"
            flat
            dense
            round
            icon="edit"
            clickable
            @click.stop="
              () => {
                dialogStatus = 'edit';
                dialog = true;
                gender = props.row.name;
                editId = props.row.id;
              }
            "
          >
            <q-tooltip>แก้ไขข้อมูล</q-tooltip>
          </q-btn>
          <q-btn
            color="red"
            flat
            dense
            round
            icon="delete"
            @click.stop.prevent="onDeleteData(props.row.id)"
          >
            <q-tooltip>ลบข้อมูล</q-tooltip>
          </q-btn>
        </q-td>
        <q-td v-for="col in props.cols" :key="col.id">
          <div>
            {{ col.value }}
          </div>
        </q-td>
      </q-tr>
    </template>
  </d-table>

  <DialogForm
    v-model:dialog="dialog"
    v-model:data="gender"
    v-model:personal-name="personalName"
    v-model:dialog-status="dialogStatus"
    v-model:edit-id="editId"
    :add-data="addData"
    :fetch-data="fetchData"
    :edit-data="editData"
  />
</template>
